package DataSetWays;
use Data::Dumper;

use DBI;
$VERSION = 0.0.3;
$DBName = 'osm.db';
sub new
{
    my $self = {};
    bless $self;
    $dbargs = {AutoCommit => 0,
               PrintError => 1};
    $self         = shift; # Instanzoverhead
    my ($extData) = shift; # Benoetigte Daten

    $dbh = DBI->connect("dbi:SQLite:dbname=$extData","","",$dbargs);
    $dbh->do("PRAGMA synchronous=0");
    $dbh->do("PRAGMA journal_mode = off");  
    $dbh->do("PRAGMA encoding = 'UTF-8'");
    $insWayHandle  = $dbh->prepare("INSERT INTO Ways(ID,RefID) VALUES (?,?)");
    $insWayAHandle = $dbh->prepare("INSERT INTO WaysAttr(ID,k,v) VALUES (?,?,?)");
    ResetVarsWays();
    return $self;
}

#############################################################################
# Aufteilen der Zeile in Nodes 
#############################################################################
sub CrunchLine
{
  my ($self)    = shift; # Instanzoverhead
  my ($extData) = shift; # Benoetigte Daten
  
  if ($extData  =~ /<way id=\"(.+?)\"/)
  {
  	SetWayIDTo($1);
  	return 1;
  }
  if ($extData  =~ /<nd ref=\"(.+?)\"\/>/)
  {
  	SetNewRefID($1);
  	return 1;
  }
  if ($extData  =~ /<nd ref=\"(.+?)\">/)
  {
    print "Inkonsistente node reference gefunden! Zeile endet nicht auf '/>'\n";
    die();
  }
  # -------------------------------------------------------------------------
  if ($extData  =~ /<tag k=\"(.+?)\" v=\"(.+?)\"/)
  {
  	SetAttributes($1,$2);
  	return 1;
  }
  # -------------------------------------------------------------------------
  if ($extData  =~ /<way .+?\/>/i)  { print "Way wurde durch '/>' abgeschlossen!\n$extData\n"; die(); }
  if ($extData  =~ /<\/way>/i)      { SchliesseDatensatzAb(); return 99; }
  return 0;
}
#############################################################################
sub SetWayIDTo
{
  my ($extData) = shift; # Benoetigte Daten
  $WayID = $extData;
  return 0;
}
#############################################################################
sub SetNewRefID
{
  my ($extData) = shift; # Benoetigte Daten
  push(@Ref, $extData);
  return 0;
}
#############################################################################
sub SetAttributes
{
  my ($extKey) = shift;    # Benoetigte Daten
  my ($extVal) = shift;    # Benoetigte Daten
  $AttrWays{$extKey} = $extVal;
  return 0;
  #print "Attr: $extKey,$extVal\n";
}
#############################################################################
sub ResetVarsWays
{
        $WayID    = 0;
        %AttrWays = ();
        undef (@Ref);     
}
#############################################################################
sub SchliesseDatensatzAb
{
  for ($i = 0; $i <= $#Ref; $i++)
  {
     my ($rId) = shift(@Ref);
     #$SQL = "INSERT INTO Ways(ID,RefID) VALUES ($WayID,$rId)";
     $insWayHandle->execute($WayID,$rId);
     #$dbh->do($SQL);     
  }
	while ( ($k,$v) = each %AttrWays ) 
  {
	  #$SQL = "INSERT INTO WaysAttr(ID,k,v) VALUES ($WayID, '$k', '$v')";
    #$dbh->do($SQL);
    $insWayAHandle->execute($WayID,"$k","$v");
  }
  $dbh->commit();
  ResetVarsWays();
}
1;
