package DatabaseCreator;

use Switch;
use DB_File;
use DBI;

$VERSION = 0.0.3;

sub new 
{
    my $self = {};
    bless $self;
    
    $self = shift;         # Instanzoverhead
    my ($extData) = shift; # Benoetigte Daten
    
    $dbargs = {AutoCommit => 1,
               PrintError => 1};
    
    my $CreateTables = 0;
    if (!-f $extData) { $CreateTables = 1; }
    
    $dbh = DBI->connect("dbi:SQLite:dbname=$extData","","",$dbargs);
    $dbh->do("PRAGMA synchronous=0"); #
    $dbh->do("PRAGMA journal_mode = off");
    $dbh->do("PRAGMA encoding = 'UTF-8'");

    if ($CreateTables == 1) 
    {
        $dbh->do("CREATE TABLE Nodes         (ID INTEGER, Lat REAL key, Lon REAL key)");
        $dbh->do("CREATE TABLE Attr          (ID INTEGER, k TEXT, v TEXT)");
        $dbh->do("CREATE TABLE Ways          (ID INTEGER, RefID INT key)");
        $dbh->do("CREATE TABLE WaysAttr      (ID INTEGER, k Text, v TEXT)");
        $dbh->do("CREATE TABLE Relations     (ID INTEGER, Role Text, Ref INTEGER key, Type TEXT)");
        $dbh->do("CREATE TABLE RelationsAttr (ID INTEGER, k Text, v TEXT)");
    }
    $dbh->disconnect();    
    return $self;
} 
sub CreateIndices
{
    $self = shift;         # Instanzoverhead
    my ($extData) = shift; # Benoetigte Daten

    $dbargs = {AutoCommit => 1,
               PrintError => 1};

    $dbh = DBI->connect("dbi:SQLite:dbname=$extData","","",$dbargs);
    
    $dbh->do("PRAGMA synchronous=0"); 
    $dbh->do("PRAGMA journal_mode = off");
    $dbh->do("PRAGMA encoding = 'UTF-8'");

#    $dbh->do("CREATE INDEX 'idx_Nodes' ON 'Nodes' (Lat,Lon)");
    print "Lege Index auf Node-Attribute an\n";
    $dbh->do("CREATE INDEX 'idx_Attr_ID' ON Attr (ID)");
    print "Lege Index auf Weg-Attribute an\n";
    $dbh->do("CREATE INDEX 'idx_WaysAttr_ID' ON WaysAttr (ID)");
    print "Lege Index auf Relationen an\n";
    $dbh->do("CREATE INDEX 'idx_Relations_ID' ON Relations (ID)");
    print "Lege Index auf Relationen-Attribute an\n";
    $dbh->do("CREATE INDEX 'idx_RelationsAttr_ID' ON RelationsAttr (ID)");

}
1;
